%
% Jacobi, GS and SOR 
%
clear all;
close all;

n = 32;
H = hilb(n);
xtrue = ones(n,1);
b = H*xtrue;
tol = 1e-4;
IterMax = 200;
x0 = zeros(n,1);

[x,iter,flag] = Jacobi(H,b,x0,tol,IterMax);
if flag==1
    fprintf('Jacobi: Iter=%d, relres=%.4e\n', iter, norm(b-H*x)/norm(b));
else
    disp('Jacobi: ')
end

[x,iter,flag] = GS(H,b,x0,tol,IterMax);
if flag==1
    fprintf('Gauss-Seidel: Iter=%d, relres=%.4e\n', iter, norm(b-H*x)/norm(b));
else
    disp('Gauss-Seidel: ')
end
%%%%% ========== End of the main program ===========================


% Jacobi iteration
function [x,iter,flag] = Jacobi(A,b,x,tol,IterMax)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%  Ĵ  %%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%
end

% Gauss-Seidel iteration
function [x,iter,flag] = GS(A,b,x,tol,IterMax)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%  Ĵ  %%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%
end

